import jfftw.*;
import ptolemy.plot.*;

/**     Test program to take Complex FT of a one-dimensional sine wave
 */
public class SineWave {
    public static void main(String args[]) {
	if (args.length < 1) {
	    System.out.println("Usage: SineWave freq");
	    System.exit(1);
	}
	double freq = Double.parseDouble(args[0]);
	System.out.println("Frequency is: " + freq);


	ComplexDataArray signal = new ComplexDataArray(100);

	for(int i = 0 ; i < signal.getWidth(); i++) {
	    double t = 2.0*Math.PI*freq*i;
	    signal.setComplex(i,Math.cos(t),0.0);
	    signal.add(i,0.0,Math.sin(2*t));
	}


	signal.centreFourier();
	// signal.fourier();
	signal.setConversion(Complex.IMAG);

	Plot plot = new Plot();
	for(int i = 0; i < signal.getWidth(); i++) {
	    plot.addPoint(0,(double)i,signal.getDouble(i),true);
	}

	PlotFrame frame = new PlotFrame("Plot",plot);
	frame.setSize(600,400);
	frame.setVisible(true);


    }
}