import uk.ac.ed.ph.jfftw.*;

/**     Simple test program for two dimensional FFTs using
 *      ComplexDataArray
 */


public class TwoDimensionalComplex extends Object {
    public static void main(String args[]) {

	int width = 200;
	int height = 300;

	ComplexDataArray data = new ComplexDataArray(width,height);

	//      Set real part of random
	for(int j = 0; j < data.getHeight(); j++) {
	    for(int i = 0 ; i < data.getWidth(); i++) {
		data.setDouble(i,j,Math.random());
	    }
	}

	//      Take clone of data
	ComplexDataArray original = data.clone();
	
	//      take fft twice

	data.fourier();          // Forward
	data.fourier();          // back again (will autonormalise)

	//     take difference of real parts

	double diff = 0.0;

	for(int j = 0; j < data.getHeight(); j++) {
	    for(int i = 0; i < data.getWidth(); i++) {
		double d = data.getComplex(i,j).getReal() -
		    original.getComplex(i,j).getReal(); 
		diff += d*d;
	    }
	}

	System.out.println("Difefrence is ; " + diff);
    }
}